#ifndef _PCI8522B_DEVICE_
#define _PCI8522B_DEVICE_
//***********************************************************
// ADʵӲ
typedef struct _PCI8522B_PARA_AD     
{
	LONG Frequency;         // ɼƵ,λΪHz, [10, 80000000]
	LONG bChannelArray[2];	// ͨѡУֱ2ͨ=1ʾͨ򲻲(ֻ֧3ͨ:0 01 0123)
	LONG InputRange[2];		// ģѡ
	LONG CouplingType[2];	// (ֱ, )
	LONG M_Length;          // Mγ(), ܵȡֵΧ1-64M, MNȲܴ64M
	LONG N_Length;          // Nγ(), ܵȡֵΧ1-64M, MNȲܴ64M
	LONG TriggerMode;		// ģʽѡ
	LONG TriggerCNT;		//  ,ں󴥷ʱģʽ£˼Ч[1~2147483647]
	LONG ATRTriggerChannel;	// ATRͨѡ
	LONG TriggerSource;		// Դѡ
	LONG TriggerDir;		// ѡ(/򴥷)
	LONG TrigLevelVolt;		// ƽ(̰ģ)
	LONG ClockSource;		// ʱԴѡ(/ʱԴ)
	LONG bMasterEn;			// 豸ʹ  
							// =0豸ͨTriggerźŽ豸͵ͬź
							// =1豸ͨTriggerźΪ豸Ĵź
							// עڶģͬϵͳУֻ趨һ豸Ϊ豸趨Ϊ豸ϵͳֻһ豸ж豸ǲҪͬ轫豸趨Ϊ豸

	LONG SyncTrigSignal;	// ͬź
} PCI8522B_PARA_AD, *PPCI8522B_PARA_AD;

//***********************************************************
// ADPCI8522B_PARA_ADеInputRangeʹõӲѡ
const long PCI8522B_INPUT_N1000_P1000mV		= 0x00; // 1000mV
const long PCI8522B_INPUT_N5000_P5000mV		= 0x01; // 5000mV

// ADPCI8522B_PARA_ADеCouplingTypeʹõѡ
const long PCI8522B_COUPLING_AC				= 0x00;	// 
const long PCI8522B_COUPLING_DC				= 0x01;	// ֱ

//***********************************************************
// ADӲPCI8522B_PARA_ADеTriggerModeԱʹôģʽѡ
const long PCI8522B_TRIGMODE_MIDL			= 0x00; // м䴥
const long PCI8522B_TRIGMODE_POST			= 0x01; // 󴥷
const long PCI8522B_TRIGMODE_PRE			= 0x02; // Ԥ
const long PCI8522B_TRIGMODE_DELAY			= 0x03; // Ӳʱ

//***********************************************************
// ADӲPCI8522B_PARA_ADеATRTriggerChannelԱʹATRͨѡ
const long PCI8522B_ATRTRIG_CH0				= 0x00; // ͨ0źΪATR
const long PCI8522B_ATRTRIG_CH1				= 0x01; // ͨ1źΪATR
const long PCI8522B_ATRTRIG_CH2				= 0x02; // ͨ2źΪATR
const long PCI8522B_ATRTRIG_CH3				= 0x03; // ͨ3źΪATR

//***********************************************************
// ADӲPCI8522B_PARA_ADеTriggerSourceԴźʹõѡ
const long PCI8522B_TRIGMODE_SOFT			= 0x00; // 
const long PCI8522B_TRIGSRC_DTR				= 0x01; // ѡDTRΪԴ
const long PCI8522B_TRIGSRC_ATR				= 0x02; // ѡATRΪԴ
const long PCI8522B_TRIGSRC_TRIGGER		    = 0x03; // TriggerźŴڶ࿨ͬ

//***********************************************************
// ADӲPCI8522B_PARA_ADеTriggerDirʹõѡ
const long PCI8522B_TRIGDIR_NEGATIVE		= 0x00; // ½ش
const long PCI8522B_TRIGDIR_POSITIVE		= 0x01; // ش
const long PCI8522B_TRIGDIR_NEGAT_POSIT		= 0x02; // ±ؾ

//***********************************************************
// ADӲPCI8522B_PARA_ADеClockSourceʱԴʹõѡ
const long PCI8522B_CLOCKSRC_IN				= 0x00; // ʹڲʱ
const long PCI8522B_CLOKCSRC_PXI10M			= 0x01;	// ʹPXI10Mʱ(Ҫڶ࿨ͬ)
const long PCI8522B_CLOCKSRC_OUT			= 0x02; // ʹⲿʱ

//***********************************************************
// ADӲPCI8522B_PARA_ADеSyncTrigSignalͬźʹõѡ
const long PCI8522B_STS_TRIGGER0			= 0x00; // ͬźTRIG0 
const long PCI8522B_STS_TRIGGER1			= 0x01; // ͬźTRIG1 
const long PCI8522B_STS_TRIGGER2			= 0x02; // ͬźTRIG2 
const long PCI8522B_STS_TRIGGER3			= 0x03; // ͬźTRIG3 
const long PCI8522B_STS_TRIGGER4			= 0x04; // ͬźTRIG4 
const long PCI8522B_STS_TRIGGER5			= 0x05; // ͬźTRIG5 
const long PCI8522B_STS_TRIGGER6			= 0x06; // ͬźTRIG6 
const long PCI8522B_STS_TRIGGER7			= 0x07; // ͬźTRIG7 

//*************************************************************************************
// ADʵӲ
typedef struct _PCI8522B_STATUS_AD     
{
	LONG bADEanble;	// ADǷѾʹܣ=TRUE:ʾʹܣ=FALSE:ʾδʹ
	LONG bTrigger;  // ADǷ񱻴=TRUE:ʾѱ=FALSE:ʾδ
	LONG bComplete; // ADǷתǷ=TRUE:ʾѽ=FALSE:ʾδ
	LONG bAheadTrig;// ADǷǰ=TRUE:ʾǰ=FALSE:ʾδǰ
	LONG lCanReadPoint;	// Զȡĵ
} PCI8522B_STATUS_AD, *PPCI8522B_STATUS_AD;

//########################  #################################
// CreateFileObjectõļʽ(ָͨʵֶַʽ)
#define PCI8522B_modeRead          0x0000			// ֻļʽ
#define PCI8522B_modeWrite         0x0001			// ֻдļʽ
#define	PCI8522B_modeReadWrite     0x0002			// ȶдļʽ
#define PCI8522B_modeCreate        0x1000			// ļԴļڣؽļ0
#define PCI8522B_typeText          0x4000			// ıʽļ

//***********************************************************
// ûӿ
#ifndef _PCI8522B_DRIVER_
#define DEVAPI __declspec(dllimport)
#else
#define DEVAPI __declspec(dllexport)
#endif

#ifdef __cplusplus
extern "C" {
#endif
	//######################## ͨú #################################
	// ڱ豸
	HANDLE DEVAPI FAR PASCAL PCI8522B_CreateDevice(int DeviceID = 0);		// 豸
	HANDLE DEVAPI FAR PASCAL PCI8522B_CreateDeviceEx(LONG DevicePhysID);		// 豸(úʹID255
	int DEVAPI FAR PASCAL PCI8522B_GetDeviceCount(HANDLE hDevice);			// ȡ豸̨
	BOOL DEVAPI FAR PASCAL PCI8522B_SetDevicePhysID(HANDLE hDevice, LONG DevicePhysID); // õǰ豸ID[0:255]
	BOOL DEVAPI FAR PASCAL PCI8522B_GetDeviceCurrentID(HANDLE hDevice, PLONG DeviceLgcID, PLONG DevicePhysID); // ȡõǰ豸߼IDźID
	BOOL DEVAPI FAR PASCAL PCI8522B_ListDeviceDlg(HANDLE hDevice);			// бϵͳееĸPCI豸
    BOOL DEVAPI FAR PASCAL PCI8522B_ReleaseDevice(HANDLE hDevice);			// ر豸,ֹ,ͷԴ

	//####################### ADݶȡ #################################
	// ڴͨûЩӿ򵥡ݡɿû֪豸
	// Ͳ㸴ӵӲЭͷƱ̣ĳʼ豸Ͷȡ
	// ADɸЧʵָ١ݲɼ
    BOOL DEVAPI FAR PASCAL PCI8522B_InitDeviceAD(								// ʼ豸TRUE,豸̿ʼ.
												HANDLE hDevice,					// 豸
												PPCI8522B_PARA_AD pADPara);		// Ӳ, ڴ˺оӲ״̬

    BOOL DEVAPI FAR PASCAL PCI8522B_StartDeviceAD(								// ڳʼ֮豸
												HANDLE hDevice);				// 豸

	BOOL DEVAPI FAR PASCAL PCI8522B_SetDeviceTrigAD(								// 豸ʹ󣬲¼ֻдԴΪʱЧ
												HANDLE hDevice);				// 豸
	
	BOOL DEVAPI FAR PASCAL PCI8522B_GetDevStatusAD(
												HANDLE hDevice,					// 豸
												PPCI8522B_STATUS_AD pADStatus);	// AD״̬

	ULONG DEVAPI FAR PASCAL PCI8522B_GetSDRAMSize(								// ذDDR2СλΪMb
												HANDLE hDevice);				// 豸
												
	///////////////////////////////////////////////////////////////////////
	BOOL DEVAPI FAR PASCAL PCI8522B_ReadDeviceAD(								// DMAʽAD
												HANDLE hDevice,					// 豸
												PWORD pADBuffer,				// ڽݵû
												ULONG nReadSizeWords,			// ȡ
												PLONG nRetSizeWords);			// ʵʶȡݳ
								
    BOOL DEVAPI FAR PASCAL PCI8522B_StopDeviceAD(								// 豸֮ͣ豸
												HANDLE hDevice);				// 豸

	BOOL DEVAPI FAR PASCAL PCI8522B_ReleaseDeviceAD(								// رAD豸,ֹ,ͷԴ
												HANDLE hDevice);				// 豸

	BOOL DEVAPI FAR PASCAL PCI8522B_ADCalibration(								// 豸У׼
												HANDLE hDevice);				// 豸

	//################# ADӲ ########################
	BOOL DEVAPI FAR PASCAL PCI8522B_SaveParaAD(HANDLE hDevice, PPCI8522B_PARA_AD pADPara);  
    BOOL DEVAPI FAR PASCAL PCI8522B_LoadParaAD(HANDLE hDevice, PPCI8522B_PARA_AD pADPara);
	BOOL DEVAPI FAR PASCAL PCI8522B_ResetParaAD(HANDLE hDevice, PPCI8522B_PARA_AD pADPara);

	//################# ڴӳĴֱӲд ########################
	// ûԱ豸ֱӡ⡢Ͳ㡢ӵĿơ
	// ƶҪĿ̺ͿЧʱûʹЩӿʵ֡
	BOOL DEVAPI FAR PASCAL PCI8522B_GetDeviceBar(					// ȡָָ豸ĴBARַ
											HANDLE hDevice,			// 豸,CreateDevice
											__int64  pbPCIBar[6]);	// PCI BARеַ,PCI BARжٿõַ뿴Ӳ˵
	BOOL DEVAPI FAR PASCAL PCI8522B_GetDevVersion(					// ȡ豸̼汾
											HANDLE hDevice,			// 豸,CreateDevice
											PULONG pulFmwVersion,	// ̼汾
											PULONG pulDriverVersion);// 汾
	BOOL DEVAPI FAR PASCAL PCI8522B_WriteRegisterByte(				// 豸ӳĴռָ˿д뵥
											HANDLE hDevice,			// 豸
											__int64 pbLinearAddr,		// ָӳĴԻַ
											ULONG OffsetBytes,		// ڻַƫλ
											BYTE Value);			// ַָд뵥ֽݣַԻַƫλþ
	BOOL DEVAPI FAR PASCAL PCI8522B_WriteRegisterWord(				// д˫ֽݣͬϣ
											HANDLE hDevice, 
											__int64 pbLinearAddr, 
											ULONG OffsetBytes,  
											WORD Value);
	BOOL DEVAPI FAR PASCAL PCI8522B_WriteRegisterULong(				// дĽݣͬϣ
											HANDLE hDevice, 
											__int64 pbLinearAddr, 
											ULONG OffsetBytes,  
											ULONG Value);
	BYTE DEVAPI FAR PASCAL PCI8522B_ReadRegisterByte(				// 뵥ֽݣͬϣ
											HANDLE hDevice, 
											__int64 pbLinearAddr, 
											ULONG OffsetBytes);
	WORD DEVAPI FAR PASCAL PCI8522B_ReadRegisterWord(				// ˫ֽݣͬϣ
											HANDLE hDevice, 
											__int64 pbLinearAddr, 
											ULONG OffsetBytes);
	ULONG DEVAPI FAR PASCAL PCI8522B_ReadRegisterULong(				// ֽݣͬϣ
											HANDLE hDevice, 
											__int64 pbLinearAddr, 
											ULONG OffsetBytes);

	//################# I/O˿ֱӲд ########################
	// ûԱ豸ֱӡ⡢Ͳ㡢ӵĿơ
	// ƶҪĿ̺ͿЧʱûʹЩӿʵ֡
	// ЩҪڴͳ豸ISAߡڡڵ豸ڱPCI豸
    BOOL DEVAPI FAR PASCAL PCI8522B_WritePortByte(HANDLE hDevice, __int64 pPort, BYTE Value);
    BOOL DEVAPI FAR PASCAL PCI8522B_WritePortWord(HANDLE hDevice, __int64 pPort, WORD Value);
    BOOL DEVAPI FAR PASCAL PCI8522B_WritePortULong(HANDLE hDevice, __int64 pPort, ULONG Value);

    BYTE DEVAPI FAR PASCAL PCI8522B_ReadPortByte(HANDLE hDevice, __int64 pPort);
    WORD DEVAPI FAR PASCAL PCI8522B_ReadPortWord(HANDLE hDevice, __int64 pPort);
    ULONG DEVAPI FAR PASCAL PCI8522B_ReadPortULong(HANDLE hDevice, __int64 pPort);


	//########################### ̲߳ ######################################
	HANDLE DEVAPI FAR PASCAL PCI8522B_CreateSystemEvent(void);			// ں¼󣬹InitDeviceIntVB̵߳Ⱥʹ
	BOOL DEVAPI FAR PASCAL PCI8522B_ReleaseSystemEvent(HANDLE hEvent);	// ͷں¼


#ifdef __cplusplus
}
#endif

// Զ
#ifndef _PCI8522B_DRIVER_
	#ifndef _WIN64
		#pragma comment(lib, "PCI8522B_32.lib")
		#pragma message("======== Welcome to use our art company's products!")
		#pragma message("======== Automatically linking with PCI8522B_32.dll...")
		#pragma message("======== Successfully linked with PCI8522B_32.dll")
	#else
		#pragma comment(lib, "PCI8522B_64.lib")
		#pragma message("======== Welcome to use our art company's products!")
		#pragma message("======== Automatically linking with PCI8522B_64.dll...")
		#pragma message("======== Successfully linked with PCI8522B_64.dll")
	#endif
#endif

#endif // _PCI8522B_DEVICE_
